Loading...
Searching...
No Matches
casacore::TableExprNodeSetElem Class Reference
tables package (libcasa_tables) » TaQL_module

Class to hold the table expression nodes for an element in a set. More...

`#include <ExprNodeSetElem.h>`

## Public Member Functions

| TableExprNodeSetElem (const TENSEBShPtr &elem)
| Create from a Base element.
| ~TableExprNodeSetElem () override=default
| TableExprNodeSetElem (const TableExprNode &node)
| Create the object for a single expression node.
| TableExprNodeSetElem (const TableExprNode *start, const TableExprNode *end, const TableExprNode *incr, Bool isEndExcl=False)
| Create the object for a discrete range.
| TableExprNodeSetElem (Bool isLeftClosed, const TableExprNode &start, const TableExprNode &end, Bool isRightClosed)
| Create the object for a continuous bounded interval.
| TableExprNodeSetElem (Bool isLeftClosed, const TableExprNode &start)
| Create the object for a continuous left-bounded interval.
| TableExprNodeSetElem (const TableExprNode &end, Bool isRightClosed)
| Create the object for a continuous right-bounded interval.
| TableExprNodeSetElem (const TableExprNode &mid, const TableExprNode &width)
| Create the object for a mid-width interval (closed on both sides).
const TENSEBShPtr & | getElem () const
| Get the internal pointer to the underlying TableExprNodeSetElemBase.
void | show (ostream &os, uInt indent) const override
| Show the node.
Bool | isDiscrete () const
| Is it a discrete set element.
Bool | isSingle () const
| Is a single value given?
Bool | isLeftClosed () const
| Is the interval left or right closed?
Bool | isRightClosed () const
Bool | isMidWidth () const
| Is the interval given as mid-width?
const TENShPtr & | start () const
| Get the start, end or increment expression.
const TENShPtr & | end () const
const TENShPtr & | increment () const
Public Member Functions inherited from casacore::TableExprNodeRep
| TableExprNodeRep (NodeDataType, ValueType, OperType, ArgType, ExprType, Int ndim, const IPosition &shape)
| Construct a node.
| TableExprNodeRep (NodeDataType, ValueType, OperType, ExprType)
| This constructor is called from the derived TableExprNodeRep.
| TableExprNodeRep (const TableExprNodeRep &)=default
| Copy constructor.
TableExprNodeRep & | operator= (const TableExprNodeRep &)=delete
| Assign to a TableExprNodeRep cannot be done.
virtual | ~TableExprNodeRep ()=default
| The destructor deletes all the underlying TableExprNode objects.
virtual Bool | isAggregate () const
| Is the node an aggegation node.
virtual TableExprInfo | getTableInfo () const
| Get the table info.
virtual void | optimize ()
| Try to optimize the node (meant for the right hand of the IN operator).
virtual void | disableApplySelection ()
| Do not apply the selection.
virtual void | applySelection (const Vector< rownr_t > &rownrs)
| Re-create the column object for a selection of rows.
virtual Double | getUnitFactor () const
| Get the unit conversion factor.
virtual void | flattenTree (std::vector< TableExprNodeRep * > &)
| Flatten the node tree by adding the node and its children to the vector.
virtual std::shared_ptr< TableExprGroupFuncBase > | makeGroupAggrFunc ()
| Create the correct immediate aggregate function object.
virtual Bool | isLazyAggregate () const
| Is the aggregate function a lazy or an immediate one?
virtual Bool | getBool (const TableExprId &id)
| Get a scalar value for this node in the given row.
virtual Int64 | getInt (const TableExprId &id)
virtual Double | getDouble (const TableExprId &id)
virtual DComplex | getDComplex (const TableExprId &id)
virtual String | getString (const TableExprId &id)
virtual TaqlRegex | getRegex (const TableExprId &id)
virtual MVTime | getDate (const TableExprId &id)
virtual MArray< Bool > | getArrayBool (const TableExprId &id)
| Get an array value for this node in the given row.
virtual MArray< Int64 > | getArrayInt (const TableExprId &id)
virtual MArray< Double > | getArrayDouble (const TableExprId &id)
virtual MArray< DComplex > | getArrayDComplex (const TableExprId &id)
virtual MArray< String > | getArrayString (const TableExprId &id)
virtual MArray< MVTime > | getArrayDate (const TableExprId &id)
void | get (const TableExprId &id, Bool &value)
| General get functions for template purposes.
void | get (const TableExprId &id, Int64 &value)
void | get (const TableExprId &id, Double &value)
void | get (const TableExprId &id, DComplex &value)
void | get (const TableExprId &id, MVTime &value)
void | get (const TableExprId &id, String &value)
void | get (const TableExprId &id, MArray< Bool > &value)
void | get (const TableExprId &id, MArray< Int64 > &value)
void | get (const TableExprId &id, MArray< Double > &value)
void | get (const TableExprId &id, MArray< DComplex > &value)
void | get (const TableExprId &id, MArray< MVTime > &value)
void | get (const TableExprId &id, MArray< String > &value)
MArray< Bool > | getBoolAS (const TableExprId &id)
| Get a value as an array, even it it is a scalar.
MArray< Int64 > | getIntAS (const TableExprId &id)
MArray< Double > | getDoubleAS (const TableExprId &id)
MArray< DComplex > | getDComplexAS (const TableExprId &id)
MArray< String > | getStringAS (const TableExprId &id)
MArray< MVTime > | getDateAS (const TableExprId &id)
virtual Bool | contains (const TableExprId &id, Bool value)
| Does a set or array contain the value?
virtual Bool | contains (const TableExprId &id, Int64 value)
virtual Bool | contains (const TableExprId &id, Double value)
virtual Bool | contains (const TableExprId &id, DComplex value)
virtual Bool | contains (const TableExprId &id, String value)
virtual Bool | contains (const TableExprId &id, MVTime value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< Bool > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< Int64 > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< Double > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< DComplex > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< String > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< MVTime > &value)
rownr_t | nrow ()
| Get the number of rows in the table associated with this expression.
virtual Bool | getColumnDataType (DataType &) const
| Get the data type of the column.
virtual Array< Bool > | getColumnBool (const Vector< rownr_t > &rownrs)
| Get the value of the expression evaluated for the entire column.
virtual Array< uChar > | getColumnuChar (const Vector< rownr_t > &rownrs)
virtual Array< Short > | getColumnShort (const Vector< rownr_t > &rownrs)
virtual Array< uShort > | getColumnuShort (const Vector< rownr_t > &rownrs)
virtual Array< Int > | getColumnInt (const Vector< rownr_t > &rownrs)
virtual Array< uInt > | getColumnuInt (const Vector< rownr_t > &rownrs)
virtual Array< Int64 > | getColumnInt64 (const Vector< rownr_t > &rownrs)
virtual Array< Float > | getColumnFloat (const Vector< rownr_t > &rownrs)
virtual Array< Double > | getColumnDouble (const Vector< rownr_t > &rownrs)
virtual Array< Complex > | getColumnComplex (const Vector< rownr_t > &rownrs)
virtual Array< DComplex > | getColumnDComplex (const Vector< rownr_t > &rownrs)
virtual Array< String > | getColumnString (const Vector< rownr_t > &rownrs)
virtual void | ranges (Block< TableExprRange > &)
| Convert the tree to a number of range vectors which at least select the same things.
NodeDataType | dataType () const
| Get the data type of the derived TableExprNode object.
Bool | isReal () const
| Is the data type real (i.e., integer or double)?
ValueType | valueType () const
| Get the value type.
void | setValueType (ValueType vtype)
| Set the value type.
OperType | operType () const
| Get the operator type.
ExprType | exprType () const
| Get the expression type.
Bool | isConstant () const
| Is the expression a constant?
const Unit & | unit () const
| Get the unit.
void | setUnit (const Unit &unit)
| Set the unit.
const Record & | attributes () const
| Get the attributes.
void | setAttributes (const Record &)
| Set the attributes.
Int | ndim () const
| Get the fixed dimensionality (same for all rows).
const IPosition & | shape () const
| Get the fixed shape (same for all rows).
const IPosition & | shape (const TableExprId &id)
| Get the shape for the given row.
virtual Bool | isDefined (const TableExprId &id)
| Is the value in the given row defined?
virtual void | adaptSetUnits (const Unit &)
| Let a set node convert itself to the given unit.

## Private Member Functions

void | init ()
| Set the data and expression type in the superclass.

## Private Attributes

TENSEBShPtr | itsElem

## Additional Inherited Members

Public Types inherited from casacore::TableExprNodeRep
enum | NodeDataType { NTBool , NTInt , NTDouble , NTComplex , NTString , NTRegex , NTDate , NTReal , NTDouCom , NTNumeric , NTAny }
| Define the data types of a node. More...
enum | ValueType { VTScalar , VTArray , VTRecord , VTSetElem , VTSet , VTIndex }
| Define the value types. More...
enum | OperType { OtPlus , OtMinus , OtTimes , OtDivide , OtModulo , OtBitAnd , OtBitOr , OtBitXor , OtBitNegate , OtEQ , OtGE , OtGT , OtNE , OtIN , OtAND , OtOR , OtNOT , OtMIN , OtColumn , OtField , OtLiteral , OtFunc , OtSlice , OtUndef , OtRownr , OtRandom }
| Define the operator types. More...
enum | ArgType { NoArr , ArrArr , ArrSca , ScaArr }
| Define the value types of the 2 arguments when arrays are involved. More...
enum | ExprType { Constant , Variable }
| Define (sub-)expression type. More...
Static Public Member Functions inherited from casacore::TableExprNodeRep
static TENShPtr | replaceConstNode (const TENShPtr &node)
| Replace a node with a constant expression by node with its value.
static void | createRange (Block< TableExprRange > &, TableExprNodeColumn *, Double start, Double end)
| Create a range object from a column and an interval.
static void | createRange (Block< TableExprRange > &)
| Create a empty range object.
static String | typeString (NodeDataType)
| Convert a NodeDataType to a string.
static String | typeString (ValueType)
| Convert a ValueType to a string.
Protected Member Functions inherited from casacore::TableExprNodeRep
virtual const IPosition & | getShape (const TableExprId &id)
| Get the shape for the given row.
void | fillExprType (const TableExprNodeRep *node)
| Set expression type to Variable if node is Variable.
Static Protected Member Functions inherited from casacore::TableExprNodeRep
static TENShPtr | convertNode (const TENShPtr &thisNode, Bool convertConstType)
| If the node is constant, it is evaluated and replaced by the appropriate TableExprNodeConst object.
Protected Attributes inherited from casacore::TableExprNodeRep
NodeDataType | dtype_p
ValueType | vtype_p
OperType | optype_p
ArgType | argtype_p
ExprType | exprtype_p
Int | ndim_p
IPosition | shape_p
Unit | unit_p
Record | attributes_p

## Detailed Description

Class to hold the table expression nodes for an element in a set.

### Intended use:

Public interface

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- TableExprNodeSet
- TableExprNodeRep

### Synopsis

This class hold a TableExprNodeSetElemBase pointer, thus points to an object of one its derived classes.
At the end of 2022 the old TableExprSetElem was split into several classes, one per element type. This class still exists for backward compatibilty, but is also useful in its own right. Its constructors create one of the derived TableExprNodeSetElemBase objects which mirror the TaQL specification, but can also be used directly in C++. The types are:

- A single value; in TaQL: max(array) or [2]
- A discrete range; in TaQL: [1:101:3]
- A continuous start/end interval; in TaQL: between 3 and 11
- A continuous mid/width interval; in TaQL: around 7 in 8

Note the difference between a discrete range and a continuous interval. The discrete range 2,6 consists of the values 1,4,7...100 The continuous intervals consists of all values between 3 and 11.

Definition at line 563 of file ExprNodeSetElem.h.

## Constructor & Destructor Documentation

## TableExprNodeSetElem() [1/7]

casacore::TableExprNodeSetElem::TableExprNodeSetElem | ( | const TENSEBShPtr & | elem | ) |

explicit

Create from a Base element.

## ~TableExprNodeSetElem()

casacore::TableExprNodeSetElem::~TableExprNodeSetElem | ( |  | ) |

override default

## TableExprNodeSetElem() [2/7]

casacore::TableExprNodeSetElem::TableExprNodeSetElem | ( | const TableExprNode & | node | ) |

explicit

Create the object for a single expression node.

## TableExprNodeSetElem() [3/7]

casacore::TableExprNodeSetElem::TableExprNodeSetElem | ( | const TableExprNode * | start,
|  | const TableExprNode * | end,
|  | const TableExprNode * | incr,
|  | Bool | isEndExcl = False )

Create the object for a discrete range.

Each of the start, end, and incr pointers can be zero meaning that they are not given (see the synopsis for an explanation). Optionally the end is inclusive (C++ and Glish style) or exclusive (Python style).

References end(), casacore::False, and start().

## TableExprNodeSetElem() [4/7]

casacore::TableExprNodeSetElem::TableExprNodeSetElem | ( | Bool | isLeftClosed,
|  | const TableExprNode & | start,
|  | const TableExprNode & | end,
|  | Bool | isRightClosed )

Create the object for a continuous bounded interval.

It can be open or closed on either side.

References end(), isLeftClosed(), isRightClosed(), and start().

## TableExprNodeSetElem() [5/7]

casacore::TableExprNodeSetElem::TableExprNodeSetElem | ( | Bool | isLeftClosed,
|  | const TableExprNode & | start )

Create the object for a continuous left-bounded interval.

References isLeftClosed(), and start().

## TableExprNodeSetElem() [6/7]

casacore::TableExprNodeSetElem::TableExprNodeSetElem | ( | const TableExprNode & | end,
|  | Bool | isRightClosed )

Create the object for a continuous right-bounded interval.

References end(), and isRightClosed().

## TableExprNodeSetElem() [7/7]

casacore::TableExprNodeSetElem::TableExprNodeSetElem | ( | const TableExprNode & | mid,
|  | const TableExprNode & | width )

Create the object for a mid-width interval (closed on both sides).

## Member Function Documentation

## end()

const TENShPtr & casacore::TableExprNodeSetElem::end | ( |  | ) | const

inline

Definition at line 632 of file ExprNodeSetElem.h.

References itsElem.

Referenced by TableExprNodeSetElem(), TableExprNodeSetElem(), and TableExprNodeSetElem().

## getElem()

const TENSEBShPtr & casacore::TableExprNodeSetElem::getElem | ( |  | ) | const

inline

Get the internal pointer to the underlying TableExprNodeSetElemBase.

Definition at line 599 of file ExprNodeSetElem.h.

References itsElem.

Referenced by casacore::TableExprNodeSet::add().

## increment()

const TENShPtr & casacore::TableExprNodeSetElem::increment | ( |  | ) | const

inline

Definition at line 634 of file ExprNodeSetElem.h.

References itsElem.

## init()

void casacore::TableExprNodeSetElem::init | ( |  | ) |

private

Set the data and expression type in the superclass.

## isDiscrete()

Bool casacore::TableExprNodeSetElem::isDiscrete | ( |  | ) | const

inline

Is it a discrete set element.

Definition at line 607 of file ExprNodeSetElem.h.

References itsElem.

## isLeftClosed()

Bool casacore::TableExprNodeSetElem::isLeftClosed | ( |  | ) | const

inline

Is the interval left or right closed?

Definition at line 616 of file ExprNodeSetElem.h.

References itsElem.

Referenced by TableExprNodeSetElem(), and TableExprNodeSetElem().

## isMidWidth()

Bool casacore::TableExprNodeSetElem::isMidWidth | ( |  | ) | const

inline

Is the interval given as mid-width?

Definition at line 623 of file ExprNodeSetElem.h.

References itsElem.

## isRightClosed()

Bool casacore::TableExprNodeSetElem::isRightClosed | ( |  | ) | const

inline

Definition at line 618 of file ExprNodeSetElem.h.

References itsElem.

Referenced by TableExprNodeSetElem(), and TableExprNodeSetElem().

## isSingle()

Bool casacore::TableExprNodeSetElem::isSingle | ( |  | ) | const

inline

Is a single value given?

Definition at line 611 of file ExprNodeSetElem.h.

References itsElem.

## show()

void casacore::TableExprNodeSetElem::show | ( | ostream & | os,
|  | uInt | indent ) const

inline override virtual

Show the node.

Reimplemented from casacore::TableExprNodeRep.

Definition at line 603 of file ExprNodeSetElem.h.

References itsElem.

## start()

const TENShPtr & casacore::TableExprNodeSetElem::start | ( |  | ) | const

inline

Get the start, end or increment expression.

Note that the shared pointer returned can be null indicating that a value was not given.

Definition at line 630 of file ExprNodeSetElem.h.

References itsElem.

Referenced by TableExprNodeSetElem(), TableExprNodeSetElem(), and TableExprNodeSetElem().

## Member Data Documentation

## itsElem

TENSEBShPtr casacore::TableExprNodeSetElem::itsElem

private

Definition at line 643 of file ExprNodeSetElem.h.

Referenced by end(), getElem(), increment(), isDiscrete(), isLeftClosed(), isMidWidth(), isRightClosed(), isSingle(), show(), and start().

The documentation for this class was generated from the following file:

- tables/TaQL/ExprNodeSetElem.h